/*
 * Copyright (c) 2023-2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef DPDK_EXT_H
#define DPDK_EXT_H

#include <stdbool.h>
#include <stdio.h>

struct smap;
struct rte_pci_addr;
struct ovs_dpdk_mempool;

const char *dpdk_get_version(void);
bool dpdk_parse_devargs_pci(const char *devargs, struct rte_pci_addr *rte_pci);

void ovs_dpdk_mempool_destroy(struct ovs_dpdk_mempool *odmp);
struct ovs_dpdk_mempool *ovs_dpdk_mempool_create(unsigned n, unsigned elt_size);
void ovs_dpdk_mempool_free(struct ovs_dpdk_mempool *odmp, void *obj);
int ovs_dpdk_mempool_alloc(struct ovs_dpdk_mempool *odmp, void **obj_p);

void malloc_dump_mempool_stats_wrapper(FILE *stream);
void malloc_dump_memzone_stats_wrapper(FILE *stream);
void dpdk_init_max_memzones(const struct smap *ovs_other_config);

#endif /* dpdk-ext.h */
